@echo off
m/nul [msgpause`CRON is being developed.]
goto fin
 :: ONCE 9/26/96
 :: uses m.exe from m405.zip or later available from
 :: 1:261/1191 as MACRO
 ::process   "dd-mm idtag command-line"   in cron.ctl

 :: dd-mm  is the day and month of today
 :: idtag  must be 8 characters or less of valid file-name chars
 :: command-line  is executed and must not require human response
 ::               when CRON is operated unattended.
 ::
 :: The semaphore file, idtag.cfl, is created after the command is
 :: executed. This file prevents re-execution of a cron.ctl item,
 :: that is, no matter how many times this batch file is executed
 :: each day, a command will only be run one time only on that day.
 ::
 :: updated 22 Aug 96
  set cron=%1
  if %1`==` set cron=cron.ctl
  if exist %cron% goto check
  echo The control file, %cron%, does not exist.
  pause
  goto fin
 :check
 :: check 1st line of CRON control file for *cron*
  m/set d=[test`[@%cron%`1]`eq`*cron*]
  if %d%==T goto init
  echo The control file, %cron%, is missing its id line.
  pause
  goto fin
 :init
 :: initialize d with 2 digit day-month
  m/set d=[dd]-[mm]
 :: init var used for batch label in DOCRON.BAT
  set i=0
 :: extract all items matching today's date into cron.tmp
  find "%d%" <cron.ctl >cron.tmp
 :: process each line in cron.tmp into these four lines:
 ::    if age-in-days-of-idtag.cfl-file==0 goto 1
 ::    call command-line
 ::    echo.>idtag.cfl
 ::    :1
 ::where the 1 is incremented for each item for today
  m "[p` `[]`nul`t`c]if [getfage`[e`t].cfl]==0 goto [++i][cr]call [e`c][cr]echo.>[e`t].cfl[cr]:[e`i]"<cron.tmp>docron.bat
  echo DOCRON.BAT
  ECHO ~~~~~~~~~~
  type docron.bat
  ECHO ~~~~~~~~~~
 :: process
  call docron.bat
 :fin
 :: clean-up
  set cron=
  set d=
  set i=
  set t=
  set c=
  erase cron.tmp
  erase docron.bat
 :: erase .cfl flag files not created today
  dir *.cfl /b | m/xqt/q [if`[getfage`[]]`ne`0] erase []
 ::( merge any lines that wrap to col 1)
