:: NLUPDATE.BAT Gary Mays 12/17/95
:: uses m.exe from M402.ZIP or later
:: uses nlup, hmsg,
:: updated 11/15/96
  f:
  cd \fd\nodelist
:: set jw to julian date of Friday (today or last friday)
  m/set  jw=[julianwk`fri`0]
  m/set jw2=[ss`%jw%`2`2]
  set   xjw2=a%jw2%
:: or:   m/set xjw2=?[ss`%jw%`2`2]
  if %1`==restart` goto restart
::
  if not exist nodelist.%jw% goto look
  goto fin
:look      ;look for tic'ed nodediff
  if not exist \file\nodediff\nodediff.%xjw2% goto trynew
:: copy + erase with Y is used to allow move with most
:: compatible method for MSDOS and OS/2 VDM
  copy \file\nodediff\nodediff.%xjw2%
  if not exist nodediff.%xjw2% goto nocopy
  echo y|erase \file\nodediff\nodediff.%xjw2%
  goto process
:trynew    ;look in the newfiles dir for freq'ed nodediff
  if not exist \newfiles\nodediff.%xjw2% goto trydnload
  copy \newfiles\nodediff.%xjw2%
  if not exist nodediff.%xjw2% goto nocopy
  echo y|erase \newfiles\nodediff.%xjw2%
  goto process
:trydnload ;look in the bbs download directory
  if not exist d:\bbs\download\nodediff.%xjw2% goto fin
  copy d:\bbs\download\nodediff.%xjw2%
  if not exist nodediff.%xjw2% goto nocopy
  echo y|erase d:\bbs\download\nodediff.%xjw2%
  goto process
:nocopy    ;nodediff not copied, notify sysop
  beep 100 50 100 50 100 50 100 50
  m/nul [msgdelay`Unable to copy incoming NODEDIFF`15000]
  hmsg -fn:nlupdate.bat -s"Unable to copy incoming NODEDIFF"
  goto toss
:process
::   gus nodediff.?%jw2%
  xarc nodediff.%xjw2%
:: merge difference file with previous nodelist
  nlup
:: nodelist has to exist and have certain nodes defined
:: when not, then error in list or my hubs have changed
:: verify validity of net261 nodelist:
:verify
:restart
  m/set nl=F:\FD\NODELIST\NODELIST.[julianwk`fri`0]
  if not exist %nl% goto nolist
  set x=Host,261,Chesapeake
  find "%x%" <%nl%
  if errorlevel 1 goto not
  set x=Hub,2100,Pikesville
  find "%x%" <%nl%
  if errorlevel 1 goto not
  set x=,1191,Gary
  find "%x%" <%nl%
  if errorlevel 1 goto not
  set x=Hub,3900,Net_261
  find "%x%" <%nl%
  if errorlevel 1 goto not
  rem set x=,1551,Internet
  set x=,1551,UUCP
  find "%x%" <%nl%
  if errorlevel 1 goto not
  set x=,3090,PerryHall
  find "%x%" <%nl%
  if errorlevel 1 goto not
:: go compile the list
  set nl=T
  goto fdnc
:nolist
  beep 100 50 100 50 100 50 100 50
  m/nul [msgdelay`NLUP unable to make %nl%`15000]
  hmsg -fn:nlupdate.bat -s"NLUP unable to make %nl%"
  goto toss
:not
  beep 100 50 100 50 100 50 100 50
  m/nul [msgdelay`'%x%' is not in %nl%`15000]
  hmsg -fn:nlupdate.bat -s"'%x%' is not in %nl%"
  goto toss
::compile
:fdnc
  \fd\fdnc
:: nodelist.fdx has to exist and be newer than the nodelist.###
  m/set x=[[getuifdate`nodelist.fdx]`gt`[getuifdate`nodelist.%jw%]]
  if %x%==T goto erase
:notupdated  ;notify sysop
  beep 100 50 100 50 100 50 100 50
  m/nul [msgdelay`FDNC did not compile the nodelist`15000]
  hmsg -fn:nlupdate.bat -s"FDNC did not compile the nodelist"
  goto toss
:erase   ;erase the old nodelist(s)
:: first, erase last weeks nodelist from fd\nodelist
:: actually, it is possible to have two or more lists because bad
:: lists are not compiled, but left there as semaphores, so have
:: to process -1 until no list exists
  set n=-1
:erase06
  m/set x=[julianwk`fri`[e`n]]
  if not exist nodelist.%x% goto erase08
  m/xqt/q erase nodelist.[julianwk`fri`[n--]]
  goto erase06
:: begin with week before last's nl and erase archived lists
:erase08
  set n=-2
:erase10
  m/set x=Z[ss`[julianwk`fri`[n--]]`2`2]
  if not exist f:\file\nodelist\nodelist.%x% goto erase20
  erase \file\nodelist\nodelist.%x%
  goto erase10
:erase20
:pack
::   rar a \file\nodediff\nodediff.r%jw2% nodediff.%jw%
::   rar a \file\nodelist\nodelist.r%jw2% nodediff.%jw%
  pkzip \file\nodediff\nodediff.z%jw2% nodediff.%jw%
  pkzip \file\nodelist\nodelist.z%jw2% nodelist.%jw%
  if exist \file\nodelist\nodelist.z%jw2% goto hatch
:: notify sysop
  beep 100 50 100 50 100 50 100 50
  m/nul [msgdelay`Unable to pack the nodelist`15000]
  hmsg -fn:nlupdate.bat -s"Unable to pack the nodelist"
  goto toss
:hatch   ; hatch the nodediff and nodelist to downlinks
  seal hatch NODEDIFF NODEDIFF.Z%jw2% Fidonet difference file for day #%jw%
  setalias f:\misc\alias.txt NODEDIFF f:\FILE\NODEDIFF\NODEDIFF.Z%JW2%
  seal hatch NODELIST NODELIST.Z%JW2% Fidonet nodelist for day #%jw%
  setalias f:\misc\alias.txt NODELIST f:\FILE\NODELIST\NODELIST.Z%JW2%
  seal announce
:: here is a good place to erase the nodediff
:kildif  ;kill the old nodediff(s)
:: first erase the incoming nodediff:
::  erase nodediff.%ajw2%
::  erase nodediff.%jw%
  erase nodediff.*
:: Kill old diffs in files area
:: first, begin with four weeks and go back until no list
  set n=-4
:kildif10
  m/set x=z[ss`[julianwk`fri`[n--]]`2`2]
  if not exist f:\file\nodediff\nodediff.%x% goto kildif20
  erase f:\file\nodediff\nodediff.%x%
  goto kildif10
:kildif20
  \max\fb -a
:toss   ; toss any robot messages
  HSTART "Tossing Robot Mail" /FS /B /C sq386p IN OUT SQUASH LINK -t
:fin
  set x=
  set n=
  set jw=
  set jw2=
  set xjw2=

