@echo off
set node=%1
if not %1.==. goto getconfig
rem SQBYTES.BAT 8/16/97 G.Mays
rem Uses M.EXE from M409.ZIP or later available from 1:261/1191
rem from 6pm until 8am US eastern time  or:
rem ftp://ftp.smart.net/pub/gdesk/M409.ZIP
echo SQBYTES [node]
echo Computes total bytes sent to a node so far this month.
echo If node is not supplied, then a node number is requested via a prompt
echo Example: sqbytes 1:261/1191.2  bytes packed for .2 of 1:261/1191
echo          sqbytes 1:261/1191    bytes packed for all of node 1191
echo          sqbytes 1:261/        bytes packed for all of net 261
echo          sqbytes 1:            bytes packed for all zone 1
rem Look for  squish.log  in the current directory, then in the same
rem  directory specified by the SQUISH environment variable that points
rem  to the config file...
:getconfig
rem first try current directory for SQUISH.LOG
set log=SQUISH.LOG
if exist %log% goto again
if %squish%.==. goto nolog
m/set log=[ucase`[fpath`[e`squish]]squish.log]
if exist %log% goto again
echo %log% does not exist
goto abort
:nolog
echo Could not locate %log%
goto abort
:again
set total=0
if not %1.==. goto find
m/set node=[?%log% - Enter node (Blank for all)]
if errorlevel 5 goto fin
:find
find "for %node%" <%log% | m/set total=[[e`total]`add`[ss`[word`[]`9]`2`255]]
if %node%.==. set node=all nodes
echo %total% bytes packed for %node% so far this month.
if %1.==. goto again
:fin
:abort
set node=
set total=

