@echo off
  if not %1.==/?. goto start
  echo XV.BAT 09/03/96 Gary Mays
  echo XV views files using specified file or file from saved picklist.
  echo XV also remembers viewed files and the line number last viewed.
  goto fin
:: updated 3/1/97
:: Uses M.EXE, CHOOSE.EXE, and SELECT.EXE from the M.EXE archive
:: M407.ZIP  or later.
:start
:: set pl to complete path of a picklist text file:
:: example: set pl=c:\picklist.lst
  set pl=d:\data\picklist.lst
:: filename line date time
::  if %1.==. goto menu_p
  goto menu_p
:menu
  m/set m=[menu`X-View`Pick previous`Select new`Remove item`Move item`Quit]
  goto menu_%m%
:menu_
:menu_q
  goto fin
:menu_p
  if not exist %pl% goto menu_p10
  select /n /t:"Select file to view. [Esc]=Menu." /set:x /g:5000<%pl%
  if errorlevel 5 goto menu
  if errorlevel 2 goto menu_p10
  set v=T
  goto view
:menu_p10
  m/nul [msgdelay`PickList file [ucase`[e`pl]] is missing or empty.`5555]
:menu_s
  m/set f=[promptgetfile`Select a file to list. ~[Esc~]=Cancel`*.*]
  if errorlevel 5 goto menu
  m/set x=[pad`[e`f]`50` ] [lpad`1`6` ] [day3$] [date] [ss`[time]`1`5]
  echo %x%>>%pl%
  set v=T
  goto view
:menu_r
  if not exist %pl% goto menu
  select /n /t:"Select file entry to remove from picklist" /set:x <%pl%
  if errorlevel 1 goto menu
  set v=F
  goto view
:menu_m
  if not exist %pl% goto menu
  select /n /t:"Select file entry to move" /set:x <%pl%
  if errorlevel 1 goto menu
  m/nul [parse` `[e`x]`f`l`d`t]
  if exist %f% goto menu_m10
  m/nul [msgpause`%f% does not exist]
  goto menu
:menu_m10
  m/set f2=[ucase`[?Enter full new path for [fname`[e`f]]`%f%]]
  if errorlevel 5 goto menu
  truename %f2% | m/set f2=[]
  m/set m=[isdir`[e`f2]]
  if %m%==T goto menu_m20
  m/nul [msgpause`The directory [e`f2], does not exist]
  goto menu_m10
:menu_m20
  m/set [if`[right`[e`f2]`1]`ne`\]f2=[e`f2]\
  m/set f2=[e`f2][fname`[e`f]]
  m/nul "[e`f] -> [e`f2]"
  m/set m=[test`[e`f]`eq`[e`f2]]
  if %m%==F goto menu_m30
  m/nul [msgpause`The specified path is the same as the original path]
  goto menu_m10
:menu_m30
  copy %f% %f2% >nul
  m/set m=[isfile`[e`f2]]
  if %m%==T goto menu_m40
  m/nul [msgpause`Unable to create [e`f2]]
  goto menu
:menu_m40
  erase %f% >nul
:: make new picklist entry
  m [pad`[e`f2]`50` ] [lpad`[e`l]`6` ] [day3$] [date] [ss`[time]`1`5]>>%pl%
:: set v=F, to let view/delete remove old entry
  set v=F
:: goto view
:view
::   v=T will view file and update picklist
::   v=F removes file from picklist only
:: parse the    'filename line# date time'
  m/nul [parse` `[e`x]`f`l`d`t]
  if %v%==F goto update
  m/set m=[isfile`[e`f]]
  if %m%==T goto view10
  m/nul [msgpause`[e`f] does not exist]
  goto menu
:view10
  choose /n/g:%l%/setl:l/t:"Viewing %f%". [F1]=Keys."<%f% >nul
  if not errorlevel 1 goto update
  m/set m=[menu`ESC: Update PickList`Yes`No]
  if not %m%.==Y. goto menu_p
  m/nul [msgdelay`Quit view with  Enter  to automatically update the picklist`3000]
:update
:: update the entry for the viewed file.
:: remove line with file name
:: when os/2 vdm, then escape the \ for FIND
  set x=%f%
  m/set [if`[dosmajor]`ge`20]x=[c`\`\\`[e`f]]
  find /v "%x%" <%pl% >%temp%\xview.$$$
  copy %temp%\xview.$$$ %pl% >nul
  if %v%==F goto menu_p
:: now add: file line# day date time
  m [pad`[e`f]`50` ] [lpad`[e`l]`6` ] [day3$] [date] [ss`[time]`1`5]>>%pl%
::
  goto menu_p
:fin
  set pl=
  set m=
  set x=
  set f=
  set l=
  set d=
  set t=
