@echo off
:: kills log file of specified net manager configuration file
:: KILLLOG.BAT 08/20/96 Gary Mays - Uses M.EXE from M405B6 or later.
  if %1.==. goto help
  if not exist %1 goto not
  set f=
  m [if`[pos`LOG`[ucase`[]]]`eq`1][parse` `[ucase`[]]`nul`f]<%1
  if %f%.==. goto nolog
  if not exist %f% goto missing
  m Resetting [e`f]
  m [date] [time] Reset by KILLLOG.BAT >%f%
  goto fin
:missing
  beep
  m/nul [msgdelay`%f% does not exist`1000]
  goto fin
:nolog
  m/nul [msgpause`No log file is defined in %1]
  goto fin
:not
  beep
  m/nul [msgpause`The netmgr configuration %1 does not exist]
  goto fin
:help
  echo KILLLOG.BAT
  echo Use: killlog netmgr.cfg
  echo Kills the log file defined in the netmgr.cfg provided, then writes
  echo [date] [time] Reset by KILLLOG.BAT
:fin
  set f=
