@echo off
:: URL.BAT 5/12/96 Gary Mays
:: updated 3/15/97
:: uses M.EXE v4.05 and SELECT.EXE from the M405.ZIP or later archive
:: URLindex has one or more lines of
::title++url
:: needs about 100+ bytes of environment space
:: env var URL holds the line number of the last url located
m/set x=[test`[efree]`gt`150]
if %x%==T goto ok
:: try to claim possible reserved space
set reserve=
set reserve2=
m/set x=[test`[efree]`gt`150]
if %x%==T goto ok
echo This batch file needs about 150 bytes of environment space.
echo Consult READ.ME and/or M.DOC for instructions on how to increase
echo the environment space.
pause
goto fin
:ok
if %1`==?` goto help
if %1`==/?` goto help
if %1`==-?` goto help
goto dourl
:help
echo URL.BAT fetches the URL for a selected title.
echo.
echo Switches:
echo   /LOCATE  Make selection, then exit.
echo   /FIND    Make selection, then exit.
echo   /EDIT    Edit the index, then exit.
ECHO   /?       Display this help screen.
echo.
echo When  there  are  no  parameters,  URL.BAT submits a menu to EDIT,
echo LOCATE, or SORT. The URL selection is written to {base}.URL and to
echo the  first  two lines of the screen.  {base}.URL is erased when no
echo selection is made (esc at selection).   {base}  is  set  into  the
echo environment  variable W in URL.BAT and is the path of the URL file
echo name less the file type.  {base}.TXT is where the URLs  are  kept.
echo {base}.TMP is used for a temporary menu file.
echo.

goto fin
::
:dourl
  m/nul [if`[isnum`[e`url]]][set`ln=[e`url]]
:: ...
:: ... set w to base file name
:: ... such as: set w=c:\util\urlindex
:: ...
  set w=d:\data\URLindex
:: ...
::  if exist %w%.TMP erase %w%.TMP >NUL
  if exist %w%.URL erase %w%.URL >NUL
  if exist %w%.TXT goto continue
  m/set m=[menu`%w%.TXT does not exist`Create it`Quit]
  goto not_%m%
:not_
:not_q
  goto fin
:not_c
  goto menu_e
:continue
::
  m/set x=[test`[pos`LOCATE`[ucase`%1`]]`ge`1]
  if %x%==T goto menu_f
  m/set x=[test`[pos`FIND`[ucase`%`]]`ge`1]
  if %x%==T goto menu_f
  m/set x=[test`[pos`EDIT`[ucase`%1`]]`ge`1]
  if %x%==T goto menu_e
  if exist %w%.tmp erase %w%.tmp >nul
:menuclear
  cls
:menu
  set x=
  set u=
  m/set m=[menu`URL Finder`Find`Add`Edit``Quit]
  goto menu_%m%
:menu_
  goto menu
:menu_q
  goto fin
:menu_e
  if %ln%.==. set ln=1
  ed /title:"Edit URL as   Title++URL "/g:%ln%%w%.TXT
  if exist %w%.TMP erase %w%.TMP >NUL
  goto sort
:menu_a
  set u=http://
:menu_a1
  m/set/halt5 x=[c`"`'`[c`=`&#61;`[?Title`[e`x]`70]]]
  if errorlevel 5 goto menuclear
  m/set l=[len`[e`x]]
  if %l%==0 goto menu_a
:menu_a2
  cls
  echo Title: %x%
  echo (Press END or RIGHT-ARROW to keep default of %u%)
  m/set/halt5 u=[msg`Press END or right-arrow to keep default, ESC to cancel][c`=`&#61;`[?URL?`[e`u]]]
  if errorlevel 5 goto menuclear
  m/set l=[len`[e`u]]
  if %l%==0 goto menu_a2
  cls
  echo Title: %x%
  echo   URL: %u%
  m/set m=[menu`"[ss`[e`x]++[e`u]`1`70]"`Accept`Edit`Cancel]
  goto add_%m%
:add_
:add_c
  goto menu
:add_a
  m [e`x]++[e`u]>>%w%.TXT
  if exist %w%.TMP erase %w%.TMP >NUL
  goto sort
:add_e
  goto menu_a1
:sort
  if exist %w%.TMP erase %w%.TMP >NUL
  m/set x=[fonly`%w%.TXT]
  sort <%w%.TXT >%w%.$$$
  if exist %w%.BAK erase %w%.BAK >NUL
  rename %w%.TXT %x%.BAK >NUL
  rename %w%.$$$ %x%.TXT >NUL
  goto menu
:menu_f
  cls
  if exist %w%.URL erase %w%.URL >NUL
  if exist %w%.tmp erase %w%.tmp >nul
:findagain
  m/set m=[?Find what? ]
  if errorlevel 5 goto menu
  if %m%.==. goto menu
:: find items and put description into %w%.tmp for selection
  find /i "%m%"<%w%.txt >%w%.url
  if not errorlevel 1 goto found
  m/nul [msgdelay`"[e`m]" not found in Title or URL`3000]
  goto findagain
:found
  m [p`++`[]``nul]<%w%.url>%w%.tmp
  erase %w%.url >nul
select /n/t"%m% in Title or URL: [Esc]=Cancel; [Enter]=Select"<%w%.tmp | m/set t=[]++
  if errorlevel 5 goto menu
  if %t%.==. goto menu
  if errorlevel 1 goto check
  if %t%.==++. goto check
  cls
  set u=
:: use find to locate the whole line::
  :: keep this on its own line because of 127 char line limit:
find "%t%"<%w%.txt>%w%
  if errorlevel 1 goto check
  ::- choose can be made to return more than one line, so allow only
  ::  one line of input. parse the line into   title and url
  ::- display url, then title on next line
  ::- write url to base.url
  m/i1/nul [p`++`[]`t`u]<%w%
  m/set l=[len`[e`u]]
  if %l%==0 goto check
:: patch actual fidonet nodediff or news file name for this week here
  m/set x=[pos`/FIDONET/FIDONEWS/`[e`u]]
  if not %x%==0 m/set u=[e`u]FNEWS[ss`CDEFGHIJKL`[[year`[pdate`monday]]`sub`1994]`1][weeknum`mon`0].ZIP
  m/set x=[pos`/FIDONET/NODELIST/`[e`u]]
  if not %x%==0 m/set u=[e`u]NODEDIFF.A[ss`[julianwk`fri`0]`2`2]
  m [e`u][cr][e`t]
  echo %u%>%w%.url
:check
  m/set x=[test`[pos`LOCATE`[ucase`%1`]]`ge`1]
  if not %x%==T goto menu
:fin
  set w=
  set x=
  set t=
  set u=
  set l=
  set m=
  set url=%ln%
  set ln=
